<template>
  <ob-table
    :group-by="'group'"
    :columns="columns"
    :items="items"
    :page-limit="pageLimit"
    :tableLayoutFixed="false"
    :showAddButton="false"
    :loading="loading"
  >
    <template slot="type" slot-scope="{ data }">
      <div
        :class="[{ 'empty-expert-price': data.item.is_expert_price_approved === false ? true : '' }, 'flexbox']"
        v-if="data.item.service"
      >
        <i
          style="font-size:28px; color:#0070A6"
          class="icon"
          v-html="getServiceIcon({ uuid: data.item.service.serviceTypeUuid }).icon"
        ></i>
        <span v-if="!data.item.isWR">
          {{ data.item.service.resourceSpeciesTitle }}
          {{ data.item.service.resourceSubtypeTitle }}
          {{ data.item.service.resourcePatternParameter }}
        </span>
        <span v-else>
          {{ data.item.service.serviceTypeTitle }}
        </span>
      </div>
    </template>

    <template slot="unit" slot-scope="{ data }">
      <div v-if="data.item.service">
        <div v-for="(unit, i) in data.item.service.serviceUnits" :key="i">{{ unit.title }}</div>
      </div>
    </template>

    <template slot="fixed" slot-scope="data">
      <div class="fixed-tarif" @click="activateFixedPriceInput($event, data.data.item.resource_uuid)">
        <i
            v-if="data.data.item.fixed_price"
            class="icon lock price-locked"
            :class="{'price-unlocked': data.data.item.fixed_price.price_stage && !data.data.item.is_fixed_price_currently}"
            @click.stop="$emit('toggleFixedPrice', data.data.item)"></i>

        <div class="cell-value">
          <div
            v-if="!!data.data.item.fixed_price && data.data.item.fixed_price.price_km"
          >{{ formatKopeykiToRubli(data.data.item.fixed_price.price_stage) }}</div>

          <div v-else class="null-cell">—</div>
        </div>

        <div class="cell-label">
          <div v-if="!!data.data.item.fixed_price && data.data.item.fixed_price.price_km">
            <span class="currency">₽/км</span>
            <span class="cell-index">{{ formatKopeykiToRubli(data.data.item.fixed_price.price_km) }}</span>
          </div>
        </div>

        <label class="fixed-tarif__table-label" v-if="activeFixedPriceInputID===data.data.item.resource_uuid">
          <input @keyup.enter="updateFixedPrice($event.target.value, data)"
                 @keyup.esc="activeFixedPriceInputID=null"
                 :value="formatKopeykiToRubli(data.data.item.fixed_price? data.data.item.fixed_price.price_stage : '')"
                 @blur="activeFixedPriceInputID=null" type="text" class="fixed-tarif__table-input">
          <span class="currency">₽</span>
        </label>
      </div>
    </template>

    <template slot="avg" slot-scope="data">
      <div class="avg-tarif"
           :class="{ 'cursor-default': data.data.item.isWR }"
           @click="!data.data.item.isWR ? $emit('openModal', MODALS.AVG_TARIF, data.data.item ) : null">
        <div class="cell-value">
          <div
            v-if="!!data.data.item.averaged_price && data.data.item.averaged_price.price_stage > 0"
          >{{ formatKopeykiToRubli(data.data.item.averaged_price.price_stage) }}</div>
          <div v-else class="null-cell">—</div>
        </div>
        <div class="cell-label">
          <div
            v-if="!!data.data.item.averaged_price && data.data.item.averaged_price.price_stage > 0"
          >
            <span class="currency">₽/км</span>

            <span
              class="cell-index"
            >{{ formatKopeykiToRubli(data.data.item.averaged_price.price_km) }}</span>
          </div>
        </div>
      </div>
    </template>

    <template slot="expert" slot-scope="data">
      <div
        :class="{ bordered: data.data.item.is_expert_price_approved === false ? true : null }"
        @click="!data.data.item.isWR ? $emit('openModal', MODALS.EXPERT_TARIF, data.data.item ) : null"
      >
        <div class="expert-tarif" :class="{'cursor-default': data.data.item.isWR}">
          <div class="cell-value">
            <div
              v-if="!!data.data.item.expert_price"
            >{{ formatKopeykiToRubli(data.data.item.expert_price.price_stage) }}</div>
            <div v-else class="null-cell">—</div>
          </div>
          <div class="cell-label">
            <div v-if="!!data.data.item.expert_price">
              <span class="currency">₽/км</span>
              <span
                class="cell-index"
              >{{ formatKopeykiToRubli(data.data.item.expert_price.price_km) }}</span>
            </div>
          </div>
        </div>
      </div>
    </template>

    <template slot="base" slot-scope="data">
      <div class="base-tarif"
           :class="{ 'cursor-default': data.data.item.isWR }"
           @click="!data.data.item.isWR ? $emit('openModal', MODALS.BASE_TARIF, data.data.item) : null">
        <div class="cell-value">
          <div
            v-if="data.data.item.base_price"
          >{{ formatKopeykiToRubli(data.data.item.base_price.price_stage) }}</div>
          <div v-else class="null-cell">—</div>
        </div>
        <div class="cell-label">
          <div v-if="data.data.item.base_price">
            <span class="currency">₽/км</span>
            <span class="cell-index">{{ formatKopeykiToRubli(data.data.item.base_price.price_km) }}</span>
          </div>
        </div>
      </div>
    </template>

    <template slot="trust" slot-scope="data">
      <div class="trust-tarif">
        <div class="cell-value">
          <div
            v-if="data.data.item.base_price_reliability && data.data.item.base_price_reliability !== null"
            :class="['reliability', data.data.item.is_good_base_price_reliability ? 'reliability-high' : 'reliability-low']"
          >{{ data.data.item.base_price_reliability }}%</div>
          <div v-else class="null-cell">—</div>
        </div>
      </div>
    </template>

    <template slot="progress" slot-scope="data">
      <div class="progress-cell">
        <div class="bar bar-filled" :style="{width: `${data.data.item.history}%` }"></div>
        <div class="value"></div>
      </div>
    </template>
  </ob-table>
</template>

<script>
import ObTable from 'common-components/src/obComponents/obTable';
import { formatKopeykiToRubli } from '@/pages/basePricesPage/utils';
import { getServiceIcon } from '@/constants/order';
import columns from './columns';

const MODALS = {
  BASE_TARIF: 'baseTarif',
  EXPERT_TARIF: 'expertTarif',
  AVG_TARIF: 'avgTarif',
};

export default {
  name: 'TarrifsTable',
  components: {
    ObTable,
  },
  props: {
    items: {
      type: Array,
      default: () => [],
    },
    loading: Boolean,
    pageLimit: Number,
  },
  data() {
    return {
      MODALS,
      columns,
      activeFixedPriceInputID: null,
      fixedPriceInputValue: null,
    };
  },
  methods: {
    getServiceIcon,
    formatKopeykiToRubli,
    activateFixedPriceInput(event, uiId){
      this.activeFixedPriceInputID = uiId;
      this.$nextTick(()=>{
        event.target.closest('.fixed-tarif').querySelector('input').focus()
      });
    },
    async updateFixedPrice(value, data){
      if(value !== formatKopeykiToRubli(data.data.item.fixed_price?.price_stage) &&
        value!== '0,00'){
        await this.$emit('updateFixedPrice', value, data);
      }
      this.activeFixedPriceInputID = null;
    }
  },
};
</script>

<style lang="scss" scoped>
  .fixed-tarif{
    position: relative;
    cursor: pointer;
    &__table-label{
      position: absolute;
      top: 15%;
      left: 5%;
      bottom: 15%;

      width: 90%;
      .currency{
        font-size: 14px;

        position: absolute;
        bottom: 2px;
        right: 2px;
      }
    }
    &__table-input{
      font-size: 16px;

      width: 100%;
      height: 100%;

      padding: 0 5% 0;
    }
    .icon{
      &.price-locked{
        transition: background 0.5s;
        border-radius: 50%;
        padding: 5px;
        &:hover{
          background: #cecece;
        }
      }
    }
  }
  .cursor-default {
    cursor: default !important;
  }
</style>
